﻿<Window x:Class="Invaders.View.InvadersPage"
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
        xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
        xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
        xmlns:local="clr-namespace:Invaders.View"
        xmlns:viewmodel="clr-namespace:Invaders.ViewModel"
        mc:Ignorable="d"
        Title="Najeźdźcy"
        Height="400" Width="400"
        Background="#FF1F1F1F"
        SizeChanged="Window_SizeChanged"
        ManipulationCompleted="Window_ManipulationCompleted" ManipulationDelta="Window_ManipulationDelta" 
        KeyDown="Window_KeyDown" KeyUp="Window_KeyUp">
    <Window.Resources>
        <viewmodel:InvadersViewModel x:Key="viewModel" />
        <viewmodel:BooleanVisibilityConverter x:Key="visiblityConverter" />

        <Style x:Key="labels" TargetType="TextBlock">
            <Setter Property="Foreground" Value="White" />
            <Setter Property="FontWeight" Value="Bold" />
            <Setter Property="FontFamily" Value="Arial" />
        </Style>
    </Window.Resources>
    <Grid x:Name="baseGrid" DataContext="{StaticResource ResourceKey=viewModel}">
        <Grid.RowDefinitions>
            <RowDefinition x:Name="gridTitle" Height="44"/>
            <RowDefinition />
        </Grid.RowDefinitions>
        <TextBlock Text="Invaders"
                   Grid.Row="0" Grid.Column="0"
                   HorizontalAlignment="Left"
                   Margin="5"
                   Style="{StaticResource labels}"
                   FontSize="24"/>
        <StackPanel Orientation="Vertical"
                    HorizontalAlignment="Right"
                    Margin="5"
                    Grid.Row="0" Grid.Column="1">
            <StackPanel Orientation="Horizontal">
                <TextBlock Text="Wave:" 
                           Style="{StaticResource labels}"
                           Margin="0,0,5,0"/>
                <TextBlock Text="{Binding Wave}" 
                           HorizontalAlignment="Right"
                           Style="{StaticResource labels}"
                           Margin="0,0,10,0"/>
                <TextBlock Text="Score:" 
                           Style="{StaticResource labels}"
                           Margin="0,0,5,0"/>
                <TextBlock Text="{Binding Score}" 
                           HorizontalAlignment="Right"
                           Style="{StaticResource labels}"/>
            </StackPanel>
            
            <ListView ItemsSource="{Binding Lives}" 
                      Background="{x:Null}" 
                      BorderBrush="{x:Null}" >
                <ListView.ItemsPanel>
                    <ItemsPanelTemplate>
                        <StackPanel Orientation="Horizontal" HorizontalAlignment="Right"/>
                    </ItemsPanelTemplate>
                </ListView.ItemsPanel>
                <ListView.ItemTemplate>
                    <DataTemplate>
                        <Image Source="/player.png" Width="27" Height="15" Stretch="Fill"/>
                    </DataTemplate>
                </ListView.ItemTemplate>
            </ListView>
        </StackPanel>

        <Border x:Name="playArea"
                BorderBrush="Blue"
                BorderThickness="2"
                CornerRadius="10"
                Background="Gray"
                Margin="5"
                Padding="2.928932188
"
                Grid.Row="1"
                Loaded="playArea_Loaded">
            <ItemsControl
                DataContext="{StaticResource viewModel}"
                ItemsSource="{Binding Path=Sprites}" >
                <ItemsControl.ItemsPanel>
                    <ItemsPanelTemplate>
                        <Canvas Background="Black" />
                    </ItemsPanelTemplate>
                </ItemsControl.ItemsPanel>
            </ItemsControl>
        </Border>

        <TextBlock Text="Game Over"
                   Grid.Row="1" Grid.ColumnSpan="2"
                   HorizontalAlignment="Center"
                   VerticalAlignment="Center"
                   Visibility="{Binding GameOver, Converter={StaticResource visiblityConverter}}" 
                   Foreground="Red" FontWeight="Bold" FontSize="40"/>
        <TextBlock Text="Paused"
                   Grid.Row="1" Grid.ColumnSpan="2"
                   HorizontalAlignment="Center"
                   VerticalAlignment="Center"
                   Visibility="{Binding Paused, Converter={StaticResource visiblityConverter}}" 
                   Foreground="Gray" FontWeight="Bold" FontSize="40"/>
    </Grid>
</Window>
